
##
# Load components
# see http://stackoverflow.com/questions/1849699
# TODO: decide between load or require!!
Dir["#{File.dirname(__FILE__)}/components/**/*.rb"].each { |f| load(f) }

module SamFront
  
  class Boostraper
    
    @hash = nil
    @first = nil

    def initialize arr
      @hash = arr
      not_a_hash if not arr.is_a? Array
    end

    def get_first
      set_chain
    end

    private 

    def self.not_a_hash
      msg = "Boostraper received #{@hash.class}, expected Hash"
      raise msg
    end

    ##
    # check:
    # http://stackoverflow.com/questions/5924495
    def set_chain
      components = []
      #load each component
      @hash.each do |c|       
        # Get component class
        clazz = nil
        if c[:class].include? "::"
          clazz = c[:class].split('::').inject(Object) {|o,c| o.const_get c}
        else
          clazz = Object.const_get(c[:class])
        end

        # Instantiate components
        comp = clazz.new
        comp.set_config c[:config]

        # Add component to list
        components << comp
      end

      # Set chain sequence
      last = components.length - 1
      components.each_with_index do |c, idx|
        c.forward components[idx+1] unless idx == last
      end
      # return the first on the chain
      return components.first
    end

  end
end